OGRE: Ogre::VertexElement Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::VertexElement Class Reference

This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaration. More...

`#include <OgreHardwareVertexBuffer.h>`

List of all members.

## Public Member Functions

| VertexElement (unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)
| Constructor, should not be called directly, call VertexDeclaration::addElement.
unsigned short | getSource (void) const
| Gets the vertex buffer index from where this element draws it's values.
size_t | getOffset (void) const
| Gets the offset into the buffer where this element starts.
VertexElementType | getType (void) const
| Gets the data format of this element.
VertexElementSemantic | getSemantic (void) const
| Gets the meaning of this element.
unsigned short | getIndex (void) const
| Gets the index of this element, only applicable for repeating elements.
size_t | getSize (void) const
| Gets the size of this element in bytes.
bool | operator== (const VertexElement &rhs) const
void | baseVertexPointerToElement (void *pBase, void **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, float **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, RGBA **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, unsigned char **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, unsigned short **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.

## Static Public Member Functions

static size_t | getTypeSize (VertexElementType etype)
| Utility method for helping to calculate offsets.
static unsigned short | getTypeCount (VertexElementType etype)
| Utility method which returns the count of values in a given type.
static VertexElementType | multiplyTypeCount (VertexElementType baseType, unsigned short count)
| Simple converter function which will turn a single-value type into a multi-value type based on a parameter.
static VertexElementType | getBaseType (VertexElementType multiType)
| Simple converter function which will a type into it's single-value equivalent - makes switches on type easier.
static void | convertColourValue (VertexElementType srcType, VertexElementType dstType, uint32 *ptr)
| Utility method for converting colour from one packed 32-bit colour type to another.
static uint32 | convertColourValue (const ColourValue &src, VertexElementType dst)
| Utility method for converting colour to a packed 32-bit colour type.
static VertexElementType | getBestColourVertexElementType (void)
| Utility method to get the most appropriate packed colour vertex element format.

## Protected Attributes

unsigned short | mSource
| The source vertex buffer, as bound to an index using VertexBufferBinding.
size_t | mOffset
| The offset in the buffer that this element starts at.
VertexElementType | mType
| The type of element.
VertexElementSemantic | mSemantic
| The meaning of the element.
unsigned short | mIndex
| Index of the item, only applicable for some elements like texture coords.

## Detailed Description

This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaration.

Remarks:
  Several vertex buffers can be used to supply the input geometry for a rendering operation, and in each case a vertex buffer can be used in different ways for different operations; the buffer itself does not define the semantics (position, normal etc), the VertexElement class does.

Definition at line 125 of file OgreHardwareVertexBuffer.h.

## Constructor & Destructor Documentation

Ogre::VertexElement::VertexElement | ( | unsigned short | source,
|  | size_t | offset,
|  | VertexElementType | theType,
|  | VertexElementSemantic | semantic,
|  | unsigned short | index = `0`
| ) |

| Constructor, should not be called directly, call VertexDeclaration::addElement.

## Member Function Documentation

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | unsigned short ** | pElem
| ) | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for ushort pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 262 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | unsigned char ** | pElem
| ) | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for char pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 250 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | RGBA ** | pElem
| ) | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for RGBA pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 237 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | float ** | pElem
| ) | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for float pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 220 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | void ** | pElem
| ) | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for void pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 206 of file OgreHardwareVertexBuffer.h.

static uint32 Ogre::VertexElement::convertColourValue | ( | const ColourValue & | src,
|  | VertexElementType | dst
| ) | `[static]`

Utility method for converting colour to a packed 32-bit colour type.

Parameters:

  | src | source colour
  | dst | The destination type

static void Ogre::VertexElement::convertColourValue | ( | VertexElementType | srcType,
|  | VertexElementType | dstType,
|  | uint32 * | ptr
| ) | `[static]`

Utility method for converting colour from one packed 32-bit colour type to another.

Parameters:

  | srcType | The source type
  | dstType | The destination type
  | ptr | Read / write value to change

static VertexElementType Ogre::VertexElement::getBaseType | ( | VertexElementType | multiType | ) | `[static]`

| Simple converter function which will a type into it's single-value equivalent - makes switches on type easier.

static VertexElementType Ogre::VertexElement::getBestColourVertexElementType | ( | void |  | ) | `[static]`

| Utility method to get the most appropriate packed colour vertex element format.

unsigned short Ogre::VertexElement::getIndex | ( | void |  | ) | const

| Gets the index of this element, only applicable for repeating elements. Definition at line 151 of file OgreHardwareVertexBuffer.h.

size_t Ogre::VertexElement::getOffset | ( | void |  | ) | const

| Gets the offset into the buffer where this element starts. Definition at line 145 of file OgreHardwareVertexBuffer.h.

VertexElementSemantic Ogre::VertexElement::getSemantic | ( | void |  | ) | const

| Gets the meaning of this element. Definition at line 149 of file OgreHardwareVertexBuffer.h.

size_t Ogre::VertexElement::getSize | ( | void |  | ) | const

| Gets the size of this element in bytes.

unsigned short Ogre::VertexElement::getSource | ( | void |  | ) | const

| Gets the vertex buffer index from where this element draws it's values. Definition at line 143 of file OgreHardwareVertexBuffer.h.

VertexElementType Ogre::VertexElement::getType | ( | void |  | ) | const

| Gets the data format of this element. Definition at line 147 of file OgreHardwareVertexBuffer.h.

static unsigned short Ogre::VertexElement::getTypeCount | ( | VertexElementType | etype | ) | `[static]`

| Utility method which returns the count of values in a given type.

static size_t Ogre::VertexElement::getTypeSize | ( | VertexElementType | etype | ) | `[static]`

| Utility method for helping to calculate offsets.

static VertexElementType Ogre::VertexElement::multiplyTypeCount | ( | VertexElementType | baseType,
|  | unsigned short | count
| ) | `[static]`

| Simple converter function which will turn a single-value type into a multi-value type based on a parameter.

bool Ogre::VertexElement::operator== | ( | const VertexElement & | rhs | ) | const

| Definition at line 187 of file OgreHardwareVertexBuffer.h.

## Member Data Documentation

unsigned short Ogre::VertexElement::mIndex`[protected]`

| Index of the item, only applicable for some elements like texture coords. Definition at line 137 of file OgreHardwareVertexBuffer.h.

size_t Ogre::VertexElement::mOffset`[protected]`

| The offset in the buffer that this element starts at. Definition at line 131 of file OgreHardwareVertexBuffer.h.

VertexElementSemantic Ogre::VertexElement::mSemantic`[protected]`

| The meaning of the element. Definition at line 135 of file OgreHardwareVertexBuffer.h.

unsigned short Ogre::VertexElement::mSource`[protected]`

| The source vertex buffer, as bound to an index using VertexBufferBinding. Definition at line 129 of file OgreHardwareVertexBuffer.h.

VertexElementType Ogre::VertexElement::mType`[protected]`

| The type of element. Definition at line 133 of file OgreHardwareVertexBuffer.h.

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:52 2008